#include <bits/stdc++.h>
#define F first
#define S second

using namespace std;

typedef long long ll;
typedef pair < ll , ll > lpair;
const ll LINF = 0x3f3f3f3f3f3f3f3fLL;
const int N = 100500;
const ll MAXX = 1000000000;

int n;
ll k;
ll a[N];

struct Seg
{
	ll x, b, k;
	ll get(ll a) const { return b + k*a; }
	bool operator < (const Seg & s) const { return x < s.x; }
};

vector < Seg > w = { {0, LINF, 0} };

ll getMin(ll x)
{
	return (upper_bound(w.begin(), w.end(), Seg({x, 0, 0})) - 1)->get(x);
}

void addLine(ll b, ll k)
{
	if (w.back().get(MAXX) <= b + k*MAXX)
		return;
	while (!w.empty() && w.back().get(w.back().x) >= b + k*w.back().x)
		w.pop_back();
	if (w.empty())
		w.push_back({0, b, k});
	else
	{
		auto ww = w.back();
		w.push_back({(b-ww.b - 1) / (ww.k-k) + 1, b, k});
	}
}

int main()
{
	scanf("%d%lld", &n, &k);
	for (int i = 0; i < n; ++i)
		scanf("%lld", &a[i]);
	a[n++] = 0;
	sort(a, a + n);
	
	ll d = 0;
	addLine(k * (n-1), n - 1);
	for (int i = 1; i < n; ++i)
	{
		d = getMin(a[i]);
		addLine(d + (k - a[i]) * (n-1-i), n - 1 - i);
	}

	printf("%lld\n", d);

	return 0;
}
