#include "testlib.h"
#include <iostream>
#include <vector>
#include <bitset>
#include <map>
#include <ctime>
#include <string>
#include <algorithm>
#include <queue>
#include <cstring>
#include <set>
#include <unordered_set>

using namespace std;

const int N = 2e3;
const int MAX = 1e4;

long long a[N], b[N];

int main(int argc, char* argv[]) 
{
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    for (int i = 0; i < n; ++i)
        a[i] = inf.readInt(),
        b[i] = inf.readInt();
        
    int ja[4], pa[4];
    for (int i = 0; i < 4; ++i)
        ja[i] = ans.readInt(1, n) - 1;
    for (int i = 0; i < 4; ++i)
        pa[i] = ouf.readInt(1, n) - 1;
    for (int i = 0; i < 4; ++i)
        for (int j = i + 1; j < 4; ++j)
            if (pa[j] == pa[i])
                quitf(_wa, "fraction %d is used more than once", pa[i] + 1);
    
    if (a[pa[0]] * b[pa[1]] > a[pa[1]] * b[pa[0]])
        quitf(_wa, "1st fraction is bigger than 2nd");
     if (a[pa[2]] * b[pa[3]] > a[pa[3]] * b[pa[2]])
        quitf(_wa, "3rd fraction is bigger than 4th");

    long long jn1 = a[ja[0]] + a[ja[2]], jd1 = b[ja[0]] + b[ja[2]];
    long long jn2 = a[ja[1]] + a[ja[3]], jd2 = b[ja[1]] + b[ja[3]];
    long long pn1 = a[pa[0]] + a[pa[2]], pd1 = b[pa[0]] + b[pa[2]];
    long long pn2 = a[pa[1]] + a[pa[3]], pd2 = b[pa[1]] + b[pa[3]];
    long long jn = jn1 * jd2 - jd1 * jn2;
    long long jd = jd1 * jd2;
    long long pn = pn1 * pd2 - pd1 * pn2;
    long long pd = pd1 * pd2;
    if (jn * pd == pn * jd)
        quitf(_ok, "OK");
    else
        if (jn * pd < pn * jd)
            quitf(_fail, "Participant has better answer." );
        else
            quitf(_wa, "Jury has better answer");
    return 0;
}
