import java.util.*;
import java.io.*;
  
public class G {
  
    void solve() {
        char[][] a = readFigure(), b = readFigure();
        int best = 0;
        int N = 900, M = 900;
        int SHIFT_N = 300, SHIFT_M = 300;
        char[][] c = new char[N][M];
          
        for (int shift = -a[0].length + 1; shift <= b[0].length - 1; shift++) {
            for (char[] cc : c) {
                Arrays.fill(cc, '.');
            }
            for (int i = 0; i < b.length; i++) {
                for (int j = 0; j < b[0].length; j++) {
                    c[i + SHIFT_N][j + SHIFT_M] = b[i][j];
                }
            }
  
            int startI = N - SHIFT_N, startJ = SHIFT_M + shift;
            for (int j = 0; j < a[0].length; j++) {
                int minB = N;
                for (int i = 0; i < N; i++) {
                    if (c[i][j + SHIFT_M + shift] != '.') {
                        minB = i;
                        break;
                    }
                }
                int maxA = -1;
                for (int i = 0; i < a.length; i++) {
                    if (a[i][j] != '.') {
                        maxA = i;
                    }
                }
                if (minB != N && maxA != -1) {
                startI = Math.min(startI, minB - maxA - 1);
                }
            }
            for (int i = 0; i < a.length; i++) {
                for (int j = 0; j < a[i].length; j++) {
                    if (a[i][j] == '*') {
                        c[i + startI][j + startJ] = a[i][j];
                    }
                }
            }
            int ans = 0;
            for (int i = 0; i < N; i++) {
                for (int j = 0; j + 1 < M; j++) {
                    if (c[i][j] == '#' && c[i][j + 1] == '*') {
                        ans++;
                    }
                }
            }
            best = Math.max(best, ans);
        }
        out.println(best);
    }
  
    char[][] readFigure() {
        int n = in.nextInt(), m = in.nextInt();
        char[][] a = new char[n][m];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextToken().toCharArray();
        }
        return a;
    }
  
    FastScanner in;
    PrintWriter out;
  
    void run() {
        in = new FastScanner();
        out = new PrintWriter(System.out);
        solve();
        out.close();
    }
  
    class FastScanner {
        BufferedReader br;
        StringTokenizer st;
  
        public FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }
  
        public FastScanner(String s) {
            try {
                br = new BufferedReader(new FileReader(s));
            } catch (FileNotFoundException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
  
        public String nextToken() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                }
            }
            return st.nextToken();
        }
  
        public int nextInt() {
            return Integer.parseInt(nextToken());
        }
  
        public long nextLong() {
            return Long.parseLong(nextToken());
        }
  
        public double nextDouble() {
            return Double.parseDouble(nextToken());
        }
    }
  
    public static void main(String[] args) {
        new G().run();
    }
}