import java.util.*;
import java.io.*;

public class hitches_dp_hs {
    FastScanner in;
    PrintWriter out;

    void readMatrix(int n, int m, char[][] matrix) {
    }

    private class Pair implements Comparable<Pair> {
      int first;
      int second;

      Pair(int first, int second) {
        this.first = first;
        this.second = second;
      }

      @Override
      public int compareTo(Pair p) {
        if (first != p.first) {
          return first - p.first;
        }
        return second - p.second;
      }

      @Override
      public boolean equals(Object o) {
        return (o instanceof Pair) && ((Pair)o).first == first && ((Pair)o).second == second;
      }

      @Override
      public int hashCode() {
        return first * 239 + second;
      }
    }

    public void solve() throws IOException {
      int nDetail = in.nextInt();
      int mDetail = in.nextInt();
      char[][] detail = new char[nDetail][];
      for (int i = 0; i < nDetail; i++) {
        detail[i] = in.next().toCharArray();
      }
      int nMold = in.nextInt();
      int mMold = in.nextInt();
      char[][] mold = new char[nMold][];
      for (int i = 0; i < nMold; i++) {
        mold[i] = in.next().toCharArray();
      }

      int maxn = 100000;
      int[] upperCell = new int[mMold];
      Arrays.fill(upperCell, -maxn);
      HashSet<Pair> used = new HashSet<>();
      for (int i = 0; i < nMold; i++) {
        for (int j = 0; j < mMold; j++) {
          if (mold[i][j] == '#') {
            upperCell[j] = Math.max(upperCell[j], nMold - i - 1);
            used.add(new Pair(nMold - i - 1, j));
          }
        }
      }
      ArrayList<Pair> dcoords = new ArrayList<>();
      for (int i = 0; i < nDetail; i++) {
        for (int j = 0; j < mDetail; j++) {
          if (detail[i][j] == '*') {
            dcoords.add(new Pair(nDetail - i - 1, j));
          }
        }
      }
      int answer = 0;
      for (int shift = -mDetail + 1; shift <= mMold; shift++) {
        Pair[] ds = new Pair[dcoords.size()];
        int moves = Integer.MAX_VALUE;
        boolean allDown = true;
        for (int i = 0; i < ds.length; i++) {
          ds[i] = new Pair(dcoords.get(i).first + nMold, dcoords.get(i).second + shift);
          int upper = (0 <= ds[i].second && ds[i].second < mMold) ? upperCell[ds[i].second] : -maxn;
          allDown &= (upper == -maxn);
          moves = Math.min(moves, ds[i].first - upper - 1);
        }
        if (allDown) {
          continue;
        }
        int hitches = 0;
        for (int i = 0; i < ds.length; i++) {
          ds[i].first -= moves;
          hitches += used.contains(new Pair(ds[i].first, ds[i].second - 1)) ? 1 : 0;
        }
        answer = Math.max(answer, hitches);
      }
      out.println(answer);
    }

    public void run() {
        try {
            in = new FastScanner();
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner() {
            try {
                br = new BufferedReader(new InputStreamReader(System.in));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new hitches_dp_hs().run();
    }
}

