#ifdef DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

mt19937 mrand(random_device{} ()); 

int rnd(int x) {
  return mrand() % x;
}

typedef long double ld;
typedef long long ll;

#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif

#define pb push_back
#define mp make_pair
#define sz(x) ((int) (x).size())
#define TASK "text"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1.0);

void precalc() {
}

const int maxn = (int) 200 + 10;
int n, m, len;

char s[maxn][maxn];
char str[maxn];

int read() {
  if (scanf("%d%d%d", &n, &m, &len) < 3) {
    return 0;
  }
  for (int i = 0; i < n; ++i) {
    scanf("%s", s[i]);
  }
  scanf("%s", str);
  return 1;
}

const int gox[4] = {1, 0, -1, 0}, goy[4] = {0, 1, 0, -1};

int cnt;

const int K1 = 5, K2 = (maxn + K1 - 1) / K1;

const int maxv = K1 * K2 * K1 * K2 * K1 * K2;

int go[maxv][4];
int okay[maxv];

int ok(int x, int y) {
  return 0 <= x && x < n && 0 <= y && y < m;
}

int get(int x, int y, int k) {
  int low = ((x % K1) * K1 + (y % K1)) * K1 + (k % K1);
  x /= K1, y /= K1, k /= K1;
  int res = ((x * K2 + y) * K2 + k) * K1 * K1 * K1 + low;
  assert(res < maxv);

  return res;
}

void getcs(int v, int &x, int &y, int &z) {
  int low = v % (K1 * K1 * K1);
  int up = v / (K1 * K1 * K1);
  z = low % K1 + K1 * (up % K2);
  low /= K1, up /= K2;
  y = low % K1 + K1 * (up % K2);
  low /= K1, up /= K2;
  x = low % K1 + K1 * (up % K2);
  assert(get(x, y, z) == v);
}

int used[maxv];

vector<int> ans;

int dfs(int v) {
  used[v] = 1;
  for (int g = 0; g < 4; ++g) {
    int u = go[v][g];
    if (u == -1) {
      continue;
    }
    //eprintf("(%d,%d,%d)->(%d,%d,%d)\n", v / maxn / maxn, v / maxn % maxn, v % maxn, u / maxn / maxn, u / maxn % maxn, u % maxn);
    if (used[u]) {
      if (used[u] == 1) {
        ans.pb(v);
        return u;
      }
      continue;
    }
    int got = dfs(u);
    if (got != -1) {
      if (got != -2) {
        ans.pb(v);
      }
      if (got == v) {
        got = -2;
      }
      return got;
    }
  }
  used[v] = 2;
  return -1;
}

int prec[maxn][maxn][maxn];

void solve() {
  memset(go, -1, sizeof(go));
  memset(okay, 0, sizeof(okay));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      for (int k = 0; k < len; ++k) {
        int v = get(i, j, k);
        prec[i][j][k] = v;
        if (str[k] != s[i][j]) {
          continue;
        }
        okay[v] = 1;
      }
    }
  }
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      for (int k = 0; k < len; ++k) {
        int v = prec[i][j][k];
        if (!okay[v]) {
          continue;
        }
        for (int g = 0; g < 4; ++g) {
          int ni = i + gox[g], nj = j + goy[g];
          int nk = (k + 1);
          if (nk == len) {
            nk = 0;
          }
          if (ok(ni, nj) && str[nk] == s[ni][nj]) {
            go[v][g] = prec[ni][nj][nk];
          }
        }
      }
    }
  }

  for (int i = 0; i < maxv; ++i) {
    used[i] = 0;
  }
  for (int i = 0; i < maxv; ++i) {
    if (used[i] || !okay[i]) {
      continue;
    }
    ans.clear();
    if (dfs(i) != -1) {
      printf("YES\n");
      reverse(ans.begin(), ans.end());

      int pos = -1;
      for (int i = 0; i < sz(ans); ++i) {
        int dx1, dy1, dk1;
        getcs(ans[i], dx1, dy1, dk1);
        if (dk1 == 0) {
          pos = i;
          break;
        }
      }
      assert(pos != -1);
      {
        int dx1, dy1, dk1;
        getcs(ans[pos], dx1, dy1, dk1);
        printf("%d\n%d %d\n", sz(ans), dx1 + 1, dy1 + 1);
      }

      string top = "";
      for (int it = 0; it < sz(ans); ++it) {
        int npos = (pos + 1);
        if (npos >= sz(ans)) {
          npos = 0;
        }
        int g = -1;

        int dx1, dy1, dk1;
        getcs(ans[pos], dx1, dy1, dk1);
        int dx2, dy2, dk2;
        getcs(ans[npos], dx2, dy2, dk2);
        int dx = dx2 - dx1, dy = dy2 - dy1;
        for (int i = 0; i < 4; ++i) {
          if (gox[i] == dx && goy[i] == dy) {
            g = i;
            break;
          }
        }
        assert(g != -1);
        top += "DRUL"[g];
        pos = npos;
      }
      printf("%s\n", top.c_str());
      return;
    }
  }
  printf("NO\n");
}

int main() {
  precalc();
#ifdef LOCAL
  freopen(TASK ".out", "w", stdout);
  assert(freopen(TASK ".in", "r", stdin));
#endif

  while (1) {
    if (!read()) {
      break;
    }
    solve();
#ifdef DEBUG
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
#endif
  }
  return 0;
}
