#include <iostream>
#include <cstdlib>
#include "testlib.h"
using namespace std;

const int N = 2e3;
const int CAP = 1e4;

int gcd(int a, int b)
{
    return b == 0 ? a : gcd(b, a % b);
}

int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);
	int cap = stoi(argv[1]);
	int n = rnd.next(4, cap);
	cout << n << endl;
	for (int i = 0; i < n; ++i)
	{
		int a = rnd.next(1, CAP);
		int b = rnd.next(1, CAP);
		int g = gcd(a ,b);
		a /= g;
		b /= g;                                 
		cout << a << " "  << b << endl;
	}
   return 0;
}